#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Code to collect information from annotated XML files
#%%
# to work with atom
#%load_ext autoreload
#%autoreload 2

import pickle
import time

import sys
sys.path.append('src/python/')

import def_classes as defc
import utils_proc

from utils_proc import call_with_out

#%%
# specify input and output files

# needed for running in atom, can be ignored
year = '1891'
input_annotatedxml = "data/AB/" + year + "/05_annotatedxml.tar.gz"
input_correctedmeta = "data/AB/" + year + "/03_correctedmeta.tar.gz"
output_collectedinfo = "data/AB/" + year + "/06_collectedinformation.pickle"

#%%
# detect arguments from sh file
input_annotatedxml = sys.argv[1]
input_correctedmeta = sys.argv[2]
output_collectedinfo = sys.argv[3]



#%%
# extract suffixes, year, folder_database
suffix_tar_annotatedxml = input_annotatedxml.split('/')[-1].split('.tar.gz')[0]
year = input_annotatedxml.split('/')[-2]
folder_database = input_annotatedxml.split(year)[0]

# title attributes
list_attributes = ['TITEL_NORMAL_DE', 'TITEL_NORMAL_FR', 'TITEL_ORIGINAL_DE', 'TITEL_ORIGINAL_FR']

#%%
# git lfs pull necessary data
# does not work in atom
command = 'git lfs pull -I ' + input_annotatedxml
call_with_out(command)

command = 'git lfs pull -I ' + input_correctedmeta
call_with_out(command)

#%%
# extract list of files
files_to_process, _ = utils_proc.get_list(year, folder_database, suffix_tar_annotatedxml)
files_to_process.sort()
files_to_process = [file for file in files_to_process if file.endswith('xml')]
print('files to process loaded')

#%%

# initialize dictionary for that year
dict_year = {}

# for each file
for file_tarpath in files_to_process:
    id_doc = file_tarpath.split('/')[-1][:8]

    # instantiate document object (always from original pdf)
    file_aux = year + '/' + id_doc + '.pdf'
    file_doc = defc.Document(file_aux, folder_database)

    # if document is a discussion
    if (file_doc.check_discussion()) and (id_doc not in ['20032463', '20032952', '20014332']):
        #print(id_doc + '\n')
        file_doc.collect_information(list_attributes)
        dict_year[id_doc] = file_doc.dict_doc

# create a pickle dump for that year
with open(output_collectedinfo, 'wb') as f:
    pickle.dump(dict_year, f)


#%%

# with open(output_collectedinfo, 'rb') as f:
    # dict_loaded = pickle.load(f)
# 
# id_ = '20026447'
# print(len(dict_loaded[id_]['dict_speeches']))
# for key, tpl in dict_loaded[id_]['dict_speeches'].items():
    # print(key, '\n', tpl[0], '\n', tpl[1][:50], '\n', tpl[1][-50:])
# 
# for key, value in dict_loaded[id_].items():
    # if key is not 'dict_speeches':
        # print(key, value)
