#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Nov 26 09:58:05 2018

@author: luissalamanca
"""

# Code to run the extraction of the XML files from the original pdfs

import os, sys

#sys.path.append('../src/python/')

import def_classes as defc
import utils_proc

import numpy as np
import time


# The input parameters are simply the year and the folder of the database
input_file = sys.argv[1]
output_file = sys.argv[2]

# Name tar out
name_tar_out = output_file.split('/')[-1].split('.tar.gz')[0]

#
year_tocomp = input_file.split('/')[-2]
folder_database = input_file.split(year_tocomp)[0]

# Start of computation
t1 = time.time()

# Downloading lfs files
print(input_file)
comm = 'git lfs pull -I ' + input_file
utils_proc.call_with_out(comm)
input_file_xml = '/'.join(input_file.split('/')[:-1]) + '/01_rawmeta.tar.gz'
comm = 'git lfs pull -I ' + input_file_xml
utils_proc.call_with_out(comm)

name_tar_file = input_file.split('/')[-1].split('.tar.gz')[0]
files_proc, _ = utils_proc.get_list(year_tocomp, folder_database, name_tar_file)

list_proc = list()
for infile in files_proc:
    
    # 8 is always the length of the id code
    infile_aux = year_tocomp + '/' + infile.split('/')[-1][:8] + '.pdf'   
    if infile_aux not in list_proc:
        list_proc.append(infile_aux)    
        d1 = defc.Document(infile_aux, folder_database)
        #try :
        d1.pdf2xml(name_outxml = name_tar_out)
        print('Extracted %s' % infile)
        #except:
        #    print("File %s prompted an error" % infile)

# Commands to get the compressed version of the file
#data/AB/${year}/02_extractedxml.tar.gz
utils_proc.compress_tar(output_file)                
            
print('Total time for year %d: %f' % (int(year_tocomp) ,(time.time() - t1)))