#!/bin/bash

year_start=$1
year_end=$2

for year in $(seq $year_start $year_end)
do
    echo $year
    
    input_lastnames=data/politicians/yearly_pickles/${year}_MPs.pickle
    input_correctedxml=data/AB/${year}/04_correctedxml.tar.gz
    input_correctedmeta=data/AB/${year}/03_correctedmeta.tar.gz
    input_notnames=data/lists/not_names.txt
    input_overlaps=data/lists/dict_overlaps.pickle
    output_annotatedxml=data/AB/${year}/05_annotatedxml.tar.gz

    renku run --isolation --output $output_annotatedxml python src/python/run_extract_discussions.py $input_lastnames $input_correctedxml $input_correctedmeta $input_notnames $input_overlaps $output_annotatedxml
done
